﻿// Get an element of a message for the top of the screen.
// msgType is the CSS class of info, warning or error
// htmlId is the optional id attribute value for the message
function getMessageElem(content, msgType, htmlId, cssClass) {
    if (!msgType)
        msgType = 'info';
    //<div class="alert alert-dismissible alert-warning"><strong>WARNING:</strong> This person already has a case entered for this initiation year. <a href="/Cases/2503">View it here</a></div>
    let eMsg = document.createElement('div');
    eMsg.classList.add('alert');
    eMsg.classList.add('alert-dismissable');
    eMsg.classList.add('alert-' + msgType);

    if (cssClass)
        eMsg.classList.add(cssClass);

    eMsg.innerHTML = content + ' <button type="button" class="close" data-dismiss="alert" aria-label="Dismiss"><span aria-hidden="true">&times;</span></button>';

    if (htmlId) 
        eMsg.id = htmlId;

    return eMsg;
}

// Creates a Bootstrap Alert message and displays it at the top of the screen in the .msg-container
function showMessage(content, msgType, htmlId, cssClass) {
    let $msg = $(getMessageElem(content, msgType, htmlId, cssClass));
    $msg.appendTo($('#message-container'));
    $msg.alert();
}

// Gets an icon for opening a modal message dialog.
function getModalMessageIcon(modalSelector, linkTitle, linkId, linkClass, iconClass) {
    // Set Defaults
    if (!modalSelector)
        modalSelector = '#modalMessage';
    if (!linkTitle)
        linkTitle = 'Click for more information';
    if (!iconClass)
        iconClass = 'fa-info-circle';

    // Build the link
    let output = `<a href="#" title="${linkTitle}" data-toggle="modal" data-target="${modalSelector}"`;
    if (linkId)
        output += ` id="${linkId}"`;
    if (linkClass)
        output += ` class="${linkClass}"`;
    output += `><i class="fa ${iconClass} ml-2"></i></a>`;

    return output;
}

function modalMessage(msg) {
    $("#dialog-message").html(msg);
    $("#dialog-message").dialog({
        modal: true,
        buttons: {
            Ok: function () {
                $(this).dialog("close");
            }
        }
    });
}

const msgTypes = {
    INFO: "info",
    ERROR: "danger",
    DANGER: "danger",
    WARNING: "warning",
    SUCCESS: "success",
    PRIMARY: "primary",
    SECONDARY: "secondary"
}