﻿// Serves the Offer Search box on the dashboard pages.
function initDashboardOfferTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardOfferId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var offerSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinyDashboardOffers/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
    {
        name: 'offers',
        display: 'name',
        limit: 20,
        source: offerSources
    })
    .on('typeahead:selected', setDashboardOfferId)
    .on('typeahead:autocomplete', setDashboardOfferId)
    .on('typeahead:change', function (e) {
        var item = $(taSelector).typeahead('val');

        if (!item) {
            $(idSelector).val('');
            //alert('Cleared');
        }

        // Call additional onChange method if provided
        if (onChanged)
            onChanged();
    });
}

function initDashboardCaseTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardCaseId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var caseSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinyDashboardCases/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
    {
        name: 'cases',
        display: 'name',
        limit: 20,
        source: caseSources
    })
    .on('typeahead:selected', setDashboardCaseId)
    .on('typeahead:autocomplete', setDashboardCaseId)
    .on('typeahead:change', function (e) {
        var item = $(taSelector).typeahead('val');

        if (!item) {
            $(idSelector).val('');
            //alert('Cleared');
        }

        // Call additional onChange method if provided
        if (onChanged) {
            onChanged();
        }
    });
}

function initDashboardRetentionTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardRetentionId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var retentionSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinyDashboardRetentions/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
    {
        name: 'retentions',
        display: 'name',
        limit: 20,
        source: retentionSources
    })
    .on('typeahead:selected', setDashboardRetentionId)
    .on('typeahead:autocomplete', setDashboardRetentionId)
    .on('typeahead:change', function (e) {
        var item = $(taSelector).typeahead('val');

        if (!item) {
            $(idSelector).val('');
            //alert('Cleared');
        }

        // Call additional onChange method if provided
        if (onChanged)
            onChanged();
    });
}

function initDashboardSearchTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardSearchId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var searchSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinySearches/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
    {
        name: 'searches',
        display: 'name',
        limit: 20,
        source: searchSources
    })
    .on('typeahead:selected', setDashboardSearchId)
    .on('typeahead:autocomplete', setDashboardSearchId)
    .on('typeahead:change', function (e) {
        var item = $(taSelector).typeahead('val');

        if (!item) {
            $(idSelector).val('');
            //alert('Cleared');
        }

        // Call additional onChange method if provided
        if (onChanged)
            onChanged();
    });
}

function initDashboardSearchByCandidateTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardSearchByCandidateId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var searchSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinyDashboardSearchesByCandidate/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
        {
            name: 'searches',
            display: 'name',
            limit: 20,
            source: searchSources
        })
        .on('typeahead:selected', setDashboardSearchByCandidateId)
        .on('typeahead:autocomplete', setDashboardSearchByCandidateId)
        .on('typeahead:change', function (e) {
            var item = $(taSelector).typeahead('val');

            if (!item) {
                $(idSelector).val('');
                //alert('Cleared');
            }

            // Call additional onChange method if provided
            if (onChanged)
                onChanged();
        });
}

function initDashboardSearchByCommitteeMemberTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setDashboardSearchByCommitteeMemberId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var searchSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinyDashboardSearchesByCommitteeMember/?names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
        {
            name: 'searches',
            display: 'name',
            limit: 20,
            source: searchSources
        })
        .on('typeahead:selected', setDashboardSearchByCommitteeMemberId)
        .on('typeahead:autocomplete', setDashboardSearchByCommitteeMemberId)
        .on('typeahead:change', function (e) {
            var item = $(taSelector).typeahead('val');

            if (!item) {
                $(idSelector).val('');
                //alert('Cleared');
            }

            // Call additional onChange method if provided
            if (onChanged)
                onChanged();
        });
}

// Serves the AU lookup box on the dashboard page.
function initDashboardAcademicUnitTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setAUId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var auSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        //prefetch: {
        //    url: '/api/TinyPeople/?isCurrentOnly=true'    // Prefetch Current People
        //},
        remote: {
            url: '/api/TinyAcademicUnits/?names=%QUERY',
            wildcard: '%QUERY'                    // %QUERY will be replace by users input in
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
        {
            name: 'AcademicUnits',
            display: 'name',
            limit: 10,
            source: auSources
        })
        .on('typeahead:selected', setAUId)
        .on('typeahead:autocomplete', setAUId)
        .on('typeahead:change', function (e) {
            var item = $(taSelector).typeahead('val');

            //if (!personInCollection(item, peeps)) {
            //    $(taSelector).val('');
            //    item = '';
            //}

            if (!item) {
                $(idSelector).val('');
                //alert('Cleared');
            }

            // Call additional onChange method if provided
            if (onChanged) {
                onChanged();
            }
        });
}

// Sets up a Person Typeahead control using the selectors for the typeahead control and value storing element
// Optional onChange method can be passed in which will be called after the default methods have completed.
function initPersonTypeahead(taSelector, idSelector, onSelected, onChanged) {
    var setPersonId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var peopleSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        //prefetch: {
        //    url: '/api/TinyPeople/?isCurrentOnly=true'    // Prefetch Current People
        //},
        remote: {
            url: '/api/TinyPeople/?names=%QUERY',
            wildcard: '%QUERY'                    // %QUERY will be replace by users input in
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
    {
        name: 'people',
        display: 'name',
        limit: 10,
        source: peopleSources
    })
    .on('typeahead:selected', setPersonId)
    .on('typeahead:autocomplete', setPersonId)
    .on('typeahead:change', function (e) {
        var item = $(taSelector).typeahead('val');

        //if (!personInCollection(item, peeps)) {
        //    $(taSelector).val('');
        //    item = '';
        //}

        if (!item) {
            $(idSelector).val('');
            //alert('Cleared');
        }

        // Call additional onChange method if provided
        if (onChanged) {
            onChanged();
        }
    });

    //$(taSelector).val('Loading...').prop('disabled', true);

    //$.getJSON('/Api/TinyPeople/', function (data) {
    //    $(taSelector).val('').prop('disabled', false);

    //    var peeps = data;

    //    $(taSelector).typeahead({
    //        minLength: 2,
    //        highlight: true,
    //        hint: false
    //    },
    //    {
    //        name: 'people',
    //        display: 'name',
    //        limit: 7,
    //        source: peopleMatcher(peeps)
    //    })
    //    .on('typeahead:selected', setPersonId)
    //    .on('typeahead:autocomplete', setPersonId)
    //    .on('typeahead:change', function (e) {
    //        var item = $(taSelector).typeahead('val');

    //        //if (!personInCollection(item, peeps)) {
    //        //    $(taSelector).val('');
    //        //    item = '';
    //        //}

    //        if (!item) {
    //            $(idSelector).val('');
    //            //alert('Cleared');
    //        }
    //    });
    //})
    //.fail(function () {
    //    alert('An error occurred while loading the name list. Please contact an administrator.');
    //});
}

function initSchoolTypeahead(taSelector, idSelector) {
    var setSchoolId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);
    };

    var schoolSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace,
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        prefetch: {
            url: '/api/TinySchools/?countryCode=USA'    // Prefetch American Schools to make it quicker
        },
        remote: {
            url: '/api/TinySchools/?names=%QUERY',
            wildcard: '%QUERY'                    // %QUERY will be replace by users input in
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
        {
            name: 'schools',
            display: 'displayName',
            limit: 20,
            source: schoolSources
        })
        .on('typeahead:selected', setSchoolId)
        .on('typeahead:autocomplete', setSchoolId)
        .on('typeahead:change', function (e) {
            var item = $(taSelector).typeahead('val');

            //if (!personInCollection(item, schools)) {
            //    $(taSelector).val('');
            //    item = '';
            //}

            if (!item) {
                $(idSelector).val('');
                //alert('Cleared');
            }
        });

    /*
    $(taSelector).val('Loading...').prop('disabled', true);

    $.getJSON('/Api/TinySchools/', function (data) {
        $(taSelector).val('').prop('disabled', false);

        var schools = data;

        $(taSelector).typeahead({
            minLength: 2,
            highlight: true,
            hint: false
        },
            {
                name: 'schools',
                display: 'name',
                limit: 7,
                source: personMatcher(schools)
            })
            .on('typeahead:selected', setSchoolId)
            .on('typeahead:autocomplete', setSchoolId)
            .on('typeahead:change', function (e) {
                var item = $(taSelector).typeahead('val');

                if (!personInCollection(item, schools)) {
                    $(taSelector).val('');
                    item = '';
                }

                if (!item) {
                    $(idSelector).val('');
                    //alert('Cleared');
                }
            });
    })
        .fail(function () {
            alert('An error occurred while loading the institution list. Please contact an administrator.');
        });
        */
}

// If activeOnly is set then we only want active Searches returned.
function initSearchTypeahead(taSelector, idSelector, onSelected, onChanged, activeOnly) {
    var setSearchId = function (e, suggestion) {
        $(idSelector).val(suggestion.id);
        //alert(suggestion.id);

        if (onSelected) {
            onSelected();
        }
    };

    var searchSources = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: `/api/TinySearches/?activeOnly=${activeOnly}&names=%QUERY`,
            wildcard: '%QUERY'
        }
    });

    $(taSelector).typeahead({
        minLength: 2,
        highlight: true,
        hint: false
    },
        {
            name: 'searches',
            display: 'name',
            limit: 20,
            source: searchSources
        })
        .on('typeahead:selected', setSearchId)
        .on('typeahead:autocomplete', setSearchId)
        .on('typeahead:change', function (e) {
            var item = $(taSelector).typeahead('val');

            //if (!personInCollection(item, peeps)) {
            //    $(taSelector).val('');
            //    item = '';
            //}

            if (!item) {
                $(idSelector).val('');
                //alert('Cleared');
            }

            // Call additional onChange method if provided
            if (onChanged) {
                onChanged();
            }
        });
}

function personInCollection(name, coll) {
    for (x in coll) {
        if (coll[x].name === name) {
            return true;
        }
    }

    return false;
}


// Used for the typeahead person and schools selector
var peopleMatcher = function (peeps) {
    return function findMatches(q, cb) {
        var matches, substringRegex;

        matches = [];

        substrRegex = new RegExp(q, 'i');

        // iterate through the pool of strings and for any string that
        // contains the substring `q`, add it to the `matches` array
        $.each(peeps, function (i, peep) {
            if (substrRegex.test(peep.name)) {
                matches.push(peep);
            }
        });

        cb(matches);
    };
};